
ERROR_TARGET=

ifeq ($(strip $(DIRS)),)
ERROR_TARGET=you_did_not_set_dirs_variable
endif

.PHONY: $(ERROR_TARGET) all clean

CLEAN = $(MAKE) clean

all: $(ERROR_TARGET)
	@for dir in $(DIRS); \
	do \
	  echo "entering $$dir"; \
	  test $$dir != .. && (cd $$dir && $(MAKE)); \
	  echo "leaving $$dir"; \
	done

clean: $(ERROR_TARGET)
	@for dir in $(DIRS); \
	do \
	  echo "entering $$dir"; \
	  test $$dir != .. && (cd $$dir && $(CLEAN)); \
	  echo "leaving $$dir"; \
	done

$(ERROR_TARGET):
	@echo "You must specify which directorys to iterate over by setting \$$DIRS" && false
